xfstests: move xfs specific tests out of top directory
[xfstests-dev.git] / tests / xfs / 134
1 #! /bin/bash
2 # FS QA Test No. 134
3 #
4 # test to reproduce PV951636:
5 #   project quotas not updated if a file is mv'd into that directory
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2006 Silicon Graphics, Inc.  All Rights Reserved.
9 #
10 # This program is free software; you can redistribute it and/or
11 # modify it under the terms of the GNU General Public License as
12 # published by the Free Software Foundation.
13 #
14 # This program is distributed in the hope that it would be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
17 # GNU General Public License for more details.
18 #
19 # You should have received a copy of the GNU General Public License
20 # along with this program; if not, write the Free Software Foundation,
21 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
22 #
23 #-----------------------------------------------------------------------
24 #
25
26 seq=`basename $0`
27 echo "QA output created by $seq"
28
29 here=`pwd`
30 tmp=/tmp/$$
31 status=1        # failure is the default!
32
33 # get standard environment, filters and checks
34 . ./common.rc
35 . ./common.filter
36 . ./common.quota
37
38 _cleanup()
39 {
40         cd /
41         umount $SCRATCH_MNT 2>/dev/null
42         rm -f $tmp.*
43 }
44 trap "_cleanup; exit \$status" 0 1 2 3 15
45
46 # real QA test starts here
47 _supported_fs xfs
48 _supported_os Linux IRIX
49
50 _require_xfs_quota
51
52 dir=$SCRATCH_MNT/project
53
54 #project quota files
55 cat >$tmp.projects <<EOF
56 1:$dir
57 EOF
58
59 cat >$tmp.projid <<EOF
60 test:1
61 EOF
62
63 cp /dev/null $seq.full
64 chmod a+rwx $seq.full   # arbitrary users will write here
65
66 _require_scratch
67 _scratch_mkfs_xfs >/dev/null 2>&1
68
69 #if pquota's already in mount options then we dont need to enable
70
71 # we can't run with group quotas
72 if ( `echo $MOUNT_OPTIONS | grep -q gquota` || `echo $MOUNT_OPTIONS | grep -q grpquota` )
73 then
74     _notrun "Can't run with group quotas enabled"
75 fi
76 EXTRA_MOUNT_OPTIONS="-o pquota"
77
78 if ! _scratch_mount "$EXTRA_MOUNT_OPTIONS" >$tmp.out 2>&1
79 then
80     cat $tmp.out
81     echo "!!! mount failed"
82     exit
83 fi
84
85 src/feature -p $SCRATCH_DEV
86 [ $? -ne 0 ] && _notrun "Installed kernel does not support project quotas"
87
88
89 mkdir $dir
90 $XFS_IO_PROG -r -c "chproj -R 1" -c "chattr -R +P" $dir
91
92 xfs_quota -D $tmp.projects -P $tmp.projid -x \
93     -c "limit -p bsoft=100m bhard=100m 1" $SCRATCH_DEV
94 xfs_quota -D $tmp.projects -P $tmp.projid -x -c "repquota -inN -p" $SCRATCH_DEV | tr -s '[:space:]'
95 touch $dir/1
96 touch $dir/2
97 cp $dir/2 $dir/3
98
99 xfs_quota -D $tmp.projects -P $tmp.projid -x -c "repquota -inN -p" $SCRATCH_DEV | tr -s '[:space:]'
100
101 if [ "$HOSTOS" == "IRIX" ] ; then
102     mkfile 1M $TEST_DIR/6
103 else
104     xfs_mkfile 1M $TEST_DIR/6
105 fi
106
107 #try cp to dir
108 cp $TEST_DIR/6 $dir/6
109 xfs_quota -D $tmp.projects -P $tmp.projid -x -c "repquota -inN -p" $SCRATCH_DEV | tr -s '[:space:]'
110
111 #try mv to dir
112 mv $TEST_DIR/6 $dir/7
113
114 xfs_quota -D $tmp.projects -P $tmp.projid -x -c "repquota -inN -p" $SCRATCH_DEV | tr -s '[:space:]'
115
116 # success, all done
117 status=0
118 exit